﻿using C1.Win.C1FlexGrid;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Design;
using System.Windows.Forms;

namespace FlexGrid_CustomEditor.CustomCombo
{
    public partial class MyComboBox : ComboBox, IC1EmbeddedEditor
    {
        public MyComboBox()
        {
            InitializeComponent();
        }
        #region IC1EmbeddedEditor-Members
        // Initialize editor: select transferred value
        public void C1EditorInitialize(object value, IDictionary editorAttributes)
        {
                this.SelectedValue = value;
        }

        //Get value from editor.
        public object C1EditorGetValue()
        {
            return (base.SelectedItem as MyComboItem)?.Id;  
        }
        //Value is always TRUE.
        public bool C1EditorValueIsValid()
        {
            return true;
        }
        //Adjust editor size.
        public void C1EditorUpdateBounds(Rectangle rc)
        {
            if (rc.Height != -1 && rc.Width != -1)
            {
                this.Location = new Point(rc.X, rc.Y);
                this.Width = rc.Width;
                this.Height = this.DefaultSize.Height;
            }
            else
            {
                //Editor has scrolled out of the picture. Take over the height / width of -1.
                this.Width = -1;
                this.Height = -1;
            }
        }

        //TRUE if Escape or Enter.
        public bool C1EditorKeyDownFinishEdit(KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Escape || e.KeyCode == Keys.Enter)
                return true;
            return false;
        }

        //Format and editor value
        public string C1EditorFormat(object value, string mask)
        {
            return null;
        }

       //Style of Editors.
        public UITypeEditorEditStyle C1EditorGetStyle()
        {
            return UITypeEditorEditStyle.DropDown;
        }
        #endregion
    }
}